#include <stdint.h> /* unitN_t      */
#include <stdio.h>  /* printf()     */
#include <stdlib.h> /* EXIT_SUCCESS */
#include <string.h> /* strlen()     */


void mem_copy(uint8_t *dest, uint8_t *src, uint16_t len, void *parent_esp) {

    void *ebp = __builtin_frame_address(0);
    register void *esp asm("esp");

    uint32_t *i, *j;
    uint16_t a;

    for(j = (uint32_t*)parent_esp; j>(uint32_t*)ebp; j--) {
       printf("%p: 0x%08lx\n", (void*)j, *j);
    }

    printf("%p: mem_copy() ebp\n", ebp);

    printf("&dest = %p: 0x%08lx\n", (void*)&dest, (uint32_t)dest);
    printf("&src = %p: 0x%08lx\n", (void*)&src, (uint32_t)src);
    printf("&len = %p: 0x%x\n", (void*)&len, len);
    printf("&parent_esp = %p: 0x%08lx\n", (void*)&parent_esp, *(uint32_t*)parent_esp);

    for (i = (uint32_t*)ebp; i>=(uint32_t*)esp; i--) {
        printf("%p: 0x%08lx\n", (void*)i, *i);
    }

    printf("%p: mem_copy() esp\n", (void*)esp);

    printf("&ebp = %p: 0x%08lx\n", (void*)&ebp, *(uint32_t*)ebp);
    printf("esp = 0x%08lx\n", *(uint32_t*)esp);
    printf("&i = %p: 0x%08lx\n", (void*)&i, *(uint32_t*)i);
    printf("&j = %p: 0x%08lx\n", (void*)&j, *(uint32_t*)j);
    printf("&a = %p: 0x%x\n", (void*)&a, a);
    printf("\n");

    for(a = 0; a<len; a++) {
        dest[a] = src[a];
    }

    printf("Buffer copied.\n");

    for (i = (uint32_t*)dest+500; i>=(uint32_t*)dest; i--) {
        printf("%p: 0x%08lx\n", (void*)i, *i);
    }

    for(j = (uint32_t*)parent_esp; j>(uint32_t*)esp; j--) {
        printf("%p: 0x%08lx\n", (void*)j, *j);
    }

    i = ebp;
    i++
    printf("%p: copy_wrapper() ret addr* = 0x%08lx\n", (void*)i, *i);
    printf("\n");
   
    return;
}


void copy_wrapper(uint8_t *src, void *parent_esp) {

    void *ebp = __builtin_frame_address(0);
    register void *esp asm("esp");

    uint8_t buffer[500];
    uint16_t a;
    uint32_t *i, *j;

    // Zero out the buffer then place some marker values at the buffer start
    // and end
    for(a = 0; a < 500; a++) {
       buffer[a] = 0;
    }
    for(a = 0; a < 4; a++) {
      buffer[a] = 0x41;
      buffer[499-a] = 0x41;
    }
                               
    for(j = (uint32_t*)parent_esp; j>(uint32_t*)ebp; j--) {
        printf("%p: 0x%08lx\n", (void*)j, *j);
    }
                                   
    printf("%p: copy_wrapper() ebp\n", ebp);

    printf("&src = %p: 0x%08lx\n", (void*)&src, (uint32_t)src);
    printf("&parent_esp = %p: 0x%08lx\n", (void*)&parent_esp, *(uint32_t*)parent_esp);
    
    for (i = (uint32_t*)ebp; i>=(uint32_t*)esp; i--) {
        printf("%p: 0x%08lx\n", (void*)i, *i);
    }

    printf("%p: copy_wrapper() esp\n", esp);

    printf("&ebp = %p: 0x%08lx\n", (void*)&ebp, *(uint32_t*)ebp);
    printf("esp = 0x%08lx\n", *(uint32_t*)esp);
    printf("&buffer = %p\n", (void*)&buffer);
    printf("&a = %p: 0x%x\n", (void*)&a, a);
    printf("&i = %p: 0x%08lx\n", (void*)&i, *(uint32_t*)i);
    printf("&j = %p: 0x%08lx\n", (void*)&j, *(uint32_t*)j);
    printf("\n");

    mem_copy(buffer, src, strlen((char*)src)+1, esp);

    printf("returned to copy_wrapper()\n");

    i = (uint32_t*)ebp;
    i++;
    printf("%p: main() ret addr* = 0x%08lx\n", (void*)i, *i);

    printf("%p: main() esp\n", parent_esp);

    for(j = (uint32_t*)parent_esp; j>=(uint32_t*)esp; j--) {
        printf("%p: 0x%08lx\n", (void*)j, *j);
    }

    printf("%p: copy_wrapper() esp\n", esp);

    return;

}


int main(int32_t argc, int8_t *argv[]) {

    uint32_t *i;
    void *ebp = __builtin_frame_address(0);
    register void *esp asm("esp");

    printf("&argv[1] = %p: 0x%08lx\n", (void*)&argv[1], (uint32_t)argv[1]);
    printf("&argv = %p\n", (void*)&argv);
    printf("&argc = %p\n", (void*)&argc);

    printf("%p: main() ebp\n", ebp);

    for (i = (uint32_t*)ebp; i>=(uint32_t*)esp; i--) {
       printf("%p: 0x%08lx\n", (void*)i, *i);
    }

    printf("%p: main() esp\n", esp);

    printf("esp = 0x%08lx\n", (uint32_t)esp);
    printf("&ebp = %p: 0x%08lx\n", (void*)&ebp, (uint32_t)ebp);
    printf("&i = %p: 0x%08lx\n", (void*)&i, (uint32_t)i);
    printf("\n");

    copy_wrapper((uint8_t*)argv[1], esp);

    printf("returned to main()\n");

    return EXIT_SUCCESS;
} 
